from pyspark import SparkConf, SparkContext
import csv
from datetime import date, datetime

conf = SparkConf().setMaster('local').setAppName('klk')
sc = SparkContext(conf = conf)

def getRDDfromCSV(fileName):
    return sc.textFile(fileName).mapPartitions(lambda x: csv.reader(x))

def maximum(x,y):
    if (x[1] > y[1]):
        return x
    return y

lineup_festivala = getRDDfromCSV('./festivali/lineup_festivala.csv').map(lambda x: ((x[0],x[1]),(x[2],x[3]))).reduceByKey(lambda x,y:  maximum(x,y))
sastav_benda = getRDDfromCSV('./festivali/sastav_benda.csv').map(lambda x: (x[1],x[0]))


join_lineup_festivala_sastav_benda = lineup_festivala.map(lambda x: (x[1][0],(x[0][0],x[0][1],x[1][1]))).join(sastav_benda).map(lambda x: (x[1][1],1)).reduceByKey(lambda x,y: x+y).reduce(lambda x,y: maximum(x,y))

muzicari = getRDDfromCSV('./festivali/muzicari.csv').map(lambda x: (x[0],(x[1],x[2]))).filter(lambda x: x[0] == join_lineup_festivala_sastav_benda[0])


print(muzicari.collect())
f = file('izlaz.txt','w')
for line in muzicari.collect():
	f.write(line)
f.close()