import datetime 
from pyspark import SparkConf, SparkContext

conf = SparkConf().setMaster("local").setAppName("SparkKolokvijum")
sc = SparkContext(conf = conf)

def transform_muzicari(x):
	splits = x.split(",")

	#(idMuzicara, ime)
	return (splits[0], splits[1] + " " + splits[2])

def sastav_benda_transform(x):
	splits = x.split(",")

	date = [int(x) for x in splits[2].split("-")]
	pocetak = date[0]

	if splits[3] == "NULL":
		kraj = datetime.datetime.now().year
	else: 	
		date = [int(x) for x in splits[3].split("-")]
		kraj = date[0]
	
	#(idBenda, (idMuzicara, pocetak, kraj))
	return (splits[1], (splits[0], pocetak, kraj))

def lineup_festivala_transform(x):
	splits = x.split(",")
	
	#((idFestivala, godina), (idBenda, dan))
	return ((splits[0], int(splits[1])), (splits[2], int(splits[3])))	

def find_max(x, y):
	if x[1] > y[1]:
		return x
	return y
	


#proba = sc.read().csv("muzicari.csv")
#proba.show()

muzicari = sc.textFile("muzicari.csv").map(lambda x : transform_muzicari(x))
sastav_benda = sc.textFile("sastav_benda.csv").map(lambda x : sastav_benda_transform(x))
lineup_festivala = sc.textFile("lineup_festivala.csv").map(lambda x : lineup_festivala_transform(x))

#(idBenda, godina)
poslednji_dani = lineup_festivala.reduceByKey(lambda x, y : find_max(x, y)).map(lambda x : (x[1][0], x[0][1]))

#(idBenda, ((idMuzicara, pocetak, kraj), godina)) pre mapiranja
#(idMuzicara, brojSviranja)
sviranje_na_zavrsnom = sastav_benda.join(poslednji_dani).map(lambda x : (x[1][0][0], 1) if (x[1][0][1] <= x[1][1] and x[1][1] <= x[1][0][2]) else (x[1][0][0], 0)).reduceByKey(lambda x, y : x + y)

#(idMuzicara, (brojSviranja, ime))
rezultat = sviranje_na_zavrsnom.join(muzicari).map(lambda x : (x[1][1], x[1][0]))

#Odredjivanje najveceg broja sviranja 
max_broj_sviranja = 0
for x in rezultat.collect():
	if max_broj_sviranja < x[1]:
		max_broj_sviranja = x[1]

#Ispis muzicara koji imaju najveci broj sviranja 
for x in rezultat.collect():
	if x[1] == max_broj_sviranja:
		print(x) 
		#Upis u fajl






















