from pyspark import SparkContext
from datetime import datetime

def proveriDatum(godina, datum1, datum2):
    d1 = datetime.strptime(datum1).date().year
    if datum2 is None:
        d2 = datetime.today().date().year
    else:
        d2 = datetime.strptime(datum2).date().year
    if godina ==  d1 or godina == d2: 
        return 1
    return 0

# def prebroji(nastupi):
#     br = 0
#     for nastup in nastupi:
#         br += 1
#     return br

sc = SparkContext("local", "kolokvijum")

lineup = toRdd("lineup_festivala.csv") \
    .map(lambda x: (int(x[0]), (int(x[1]), int(x[2]), int(x[3]))) )
    #(id, (godina, idBenda, dan ))

sastavBenda = toRdd("sastav_benda.csv") \
    .map(lambda x: (int(x[1]), (int(x[0]), int(x[2]), int(x[3]))) )
    #(idBenda, (idMuzicara, datum1, datum2 ))

muzicari = toRdd("muzicari.csv") \
    .map(lambda x: (int(x[0]), (int(x[1]), int(x[2]))) )
    #(idMuzicara, (ime, prezime ))



# nalazi max dan za svaki festival
maxDan = lineup\
    .join(lineup)\
    .filter(lambda x: x[1][0][1] == x[1][1][1] and x[1][0][2] > x[1][1][2])\
    .map(lambda x: (x[1][0][1], (x[1][0][0], x[0], x[1][0][2])))\
    #(idBenda, (godina, idLineup, dan))

#spaja lineup sa sastavomBendova
muzicariKojiSuSvirali = maxDan.join(sastavBenda)\
    .filter(lambda x: proveriDatum(x[1][0][0], x[1][1][1], x[1][1][2]) == 1)\
    .map(lambda x: (x[1][1][0], (x[1][0][0])) )
    #(idMuzicara, (godinaFestivala))
    
# dodaje imena muzicara
muzicariSaImenom = muzicariKojiSuSvirali.join(muzicari)\
    .map(lambda x: (x[0], (x[1][1][0], x[1][1][1], x[1][0][0])) )
    #(idMuzicara, (ime, prezime, godinaFestivala))



# broji koliko puta su svirali poslednji put
# prebrojano = muzicariKojiSuSvirali.groupById(lambda x: prebroji(x[0]))

# print(prebrojano.collect())














