from pyspark import SparkConf, SparkContext

conf = SparkConf().setMaster("local").setAppName("SparkKolokvijum")
sc = SparkContext(conf = conf)

def getYear(dat):
    if dat == "NULL":
     return 2024
    return int(dat.split("-")[0])

#id, ime, prezime
muzicari = sc.textFile("muzicari.csv").\
        map(lambda x: x.split(",")).\
        map(lambda x: (int(x[0]),(x[1],x[2])))

#id muzicara, id benda, godinaPoc, godinaKraj
sastav_benda = sc.textFile("sastav_benda.csv").\
        map(lambda x: x.split(",")).\
        map(lambda x: (int(x[0]),(int(x[1]),getYear(x[2]),getYear(x[3]))))

#idFest, godinaFest, idBenda, dan
lineup_festivala = sc.textFile("lineup_festivala.csv").\
        map(lambda x: x.split(",")).\
        map(lambda x: (int(x[2]),(int(x[0]),int(x[1]),int(x[3]))))

maxDanFestival = lineup_festivala.\
                join(lineup_festivala).\
                filter(lambda x: x[1][0][1] == x[1][1][1])


print(maxDanFestival.collect())
print(sastav_benda.collect())
print(muzicari.collect())
