from pyspark import SparkConf, SparkContext

conf = SparkConf().setMaster("local").setAppName("app")
sc = SparkContext(conf = conf)

# (idMuzicara, (ime, prezime))
muzicari = sc.textFile("muzicari.csv").map(lambda x: x.split(",")).map(lambda x: (x[0], (x[1], x[2])))
# (idBenda, (idMuzicara, datumod, datumdo))
sastavi = sc.textFile("sastav_benda.csv").map(lambda x: x.split(",")).map(lambda x: (x[1], (x[0], int(x[2].split("-")[0]), int(x[3].split("-")[0]) if x[3] != "NULL" else 2024)))
# (idMuzicara, (idBenda, datumod, datumdo))
sastavi1 = sc.textFile("sastav_benda.csv").map(lambda x: x.split(",")).map(lambda x: (x[0], (x[1], int(x[2].split("-")[0]), int(x[3].split("-")[0]) if x[3] != "NULL" else 2024)))
# ((idFestivala, godina), (idBenda, dan))
lineupi = sc.textFile("lineup_festivala.csv").map(lambda x: x.split(",")).map(lambda x: ((x[0], int(x[1])), (x[2], x[3])))
# ((idFestivala, godina), (idBenda, maxDan))
poslednjiDani = lineupi.reduceByKey(lambda x, y: (x[0], x[1]) if x[1] > y[1] else (y[0], y[1]))
# (idBenda, (idFestivala, godina, maxDan))
poslednjiDaniBend = poslednjiDani.map(lambda x: (x[1][0], (x[0][0], x[0][1], x[1][1])))
# (idBenda, ((idFestivala, godina, maxDan), (idMuzicara, datumod, datumdo)))
join1 = poslednjiDaniBend.join(sastavi).filter(lambda x: x[1][0][1] < x[1][1][2] and x[1][0][1] >= x[1][1][1])
# (idMuzicara, brojNastupaPoslednjegDana)
join2 = join1.map(lambda x: (x[1][1][0], 1)).reduceByKey(lambda x, y: x + y)

maxNastupa = 0
for line in join2.collect():
    if line[1] > maxNastupa:
        maxNastupa = line[1]

final = join2.filter(lambda x: x[1] == maxNastupa)

final = final.join(muzicari).map(lambda x: (x[1][1][0], x[1][1][1], x[1][0]))

with open("trazeniMuzicar.csv", "w") as f:
    for line in final.collect():
        f.write(line[0] + ", " + line[1] + ", " + str(line[2]) + "\n")

#print(join1.collect())