from pyspark import SparkConf, SparkContext

conf = SparkConf().setMaster("local").setAppName("SparkKolokvijum")
sc = SparkContext(conf = conf)

def dajPoslednjiDan(list, idFestivala):
    max = 0
    for item in list:
        if item[0] == idFestivala:
            if item[1][5] > max:
                max = item[1][5]
        
    return max

muzicari = sc.textFile("muzicari.csv").map(lambda x: x.split(",")).map(lambda x: (x[0], (x[1], x[2])))
sastav_bendova = sc.textFile("sastav_benda.csv").map(lambda x: x.split(",")).map(lambda x: (x[0], (x[1], int(x[2].split("-")[0]), int(x[3].split("-")[0]) if x[3] != "NULL" else 2024)))
lineups = sc.textFile("lineup_festivala.csv").map(lambda x: x.split(",")).map(lambda x: (x[2], (x[0], int(x[1]), int(x[3]))))

muzicari_sastav = muzicari.join(sastav_bendova).map(lambda x: (x[1][1][0], (x[0], x[1][1][1], x[1][1][2])))
joined = muzicari_sastav.join(lineups).map(lambda x: (x[1][1][0], (x[1][0][0], x[0], x[1][0][1], x[1][0][2], x[1][1][1], x[1][1][2]))).reduceByKey(lambda x, y: max(x[5], y[5]))


print(joined.collect())

# with open("fajl.txt", "w") as f:
#     for line in muzicari.collect():
#         f.write(str(line[0]) + " " + line[1] + " " + line[2])