from pyspark import SparkConf, SparkContext
from datetime import date, datetime
import csv

conf = SparkConf().setMaster("local").setAppName("klk")
cs = SparkContext(conf = conf)

lineup_festivala = cs.textFile("lineup_festivala.csv").mapPartitions(lambda x: csv.reader(x)).map(lambda x: (x[2], [x[0], x[1], x[3]]))
sastav_benda = cs.textFile("sastav_benda.csv").mapPartitions(lambda x: csv.reader(x)).map(lambda x: (x[1], [x[0], x[2], x[3]]))
muzicari = cs.textFile("muzicari.csv").mapPartitions(lambda x: csv.reader(x)).map(lambda x: (x[0], [x[1], x[2]]))

print(muzicari.collect())

def sredi_datume(x):
    if(x[1][2] == "NULL"):
        x[1][2] = datetime.today().year
    else:
        x[1][2] = datetime.strptime(x[1][2], "%Y-%m-%d").date().year

    x[1][1] = datetime.strptime(x[1][1], "%Y-%m-%d").date().year
    
sastav_benda = sastav_benda.filter(lambda x: sredi_datume(x))

sastav_lineup = sastav_benda.join(lineup_festivala)

# (id benda)(idMuzicara, datum1, datum2)(idFestivala, godina, dan)

def ostavi_odgovarajuce(x):
    if(x[1][1] <= x[2][1] and x[1][2] >= x[2][1]):
        return x

sastav_lineup = sastav_lineup.filter(lambda x: ostavi_odgovarajuce(x))

sastav_lineup = sastav_lineup.map(lambda x: ((x[1][0], x[2][0]), x[2][2]))

sastav_lineup = sastav_lineup.reduceByKey(lambda x, y: x > y)

sastav_lineup = sastav_lineup.map(lambda x: ((x[0][0], x[0][1], x[0][2]), 1))

sastav_lineup = sastav_lineup.reduceByKey(lambda x, y: x + y)

def max(x):
    maximum = 0
    for sl in sastav_lineup.collect():
        if maximum < sl[1]:
            maximum = sl[1]

    return maximum


sastav_lineup = sastav_lineup.filter(lambda x: x[1] == max(x))

sastav_lineup = sastav_lineup.map(lambda x: (x[0][0], x[1]))

trazeni_muzicar = sastav_lineup.join(muzicari)

# (id muzicara)(broj dana)(ime, prezime)

trazeni_muzicar = trazeni_muzicar.map(lambda x: (x[0], [x[2][0], x[2][1], x[1]]))
trazeni_muzicar.collect()







