# име и презиме музичара који је најчешће свирао на завршним данима фестивала, као и број таквих наступа.

import datetime
from pyspark import SparkConf, SparkContext
import csv

conf=SparkConf().setManager("local").setAppName("festivali")
sc=SparkContext(conf=conf)

# idFes, godina, idBenda, dan  | u bazi
# (idBenda, idFestivala, godina, dan)
lineup_festivala=sc.textFile("lineup_festivala.csv").mapPartition(lambda x: csv.reader(x)).map(lambda x: (x[2], x[0], x[1], x[3])).filter(lambda x: x[3]==3)

# (idBenda, (idMuzicara, (godina1, godina2)))
sastav_benda=sc.textFile("sastav_benda.csv").mapPartition(lambda x: csv.reader(x)).map(lambda x: (x[0], (x[1], (int(x[2].split("-")[0]), int(x[3].split("-")[0]) if x[3]!="NULL" else 2024))))

# (idMuzicara, (ime, prezime))
muzicari=sc.textFile("muzicari.csv").mapPartition(lambda x: csv.reader(x)).map(lambda x: (x[0], (x[1], x[2])))

# lineup, sastav_benda
def da_li_je_clan_jos_uvek(x, y):
    return 0











# (idBenda, (idFestivala, godina, dan, (idMuzicara, (godina1, godina2)))) posle join
# ((idFestivala, godina), idMuzicara) posle map
lineup_sastav=lineup_festivala.join(sastav_benda).filter(lambda x: da_li_je_clan_jos_uvek(x[1][1], x[1][3][1])).map(lambda x: ((x[1][0], x[1][3][0]), x[1][1]))

# ((idFestivala, godina), (idMuzicara1, idMuzicara2, idMuzicara1))) # ovako nesto
group_by=lineup_sastav.groupByKey(lambda x: x[0]) # sintaksa

for line in group_by.collect():
    zavrsni=line.map(lambda x: (x[0], )) # drugi treba da bude broj koji se najvise pojavljuje, i to je muzicar koji je tu najvise svirao

reduce_by=zavrsni.map(lambda x: (x[1], 1)).reduceByKey(lambda x,y: x+y) # brojimo nastupe



muz=reduce_by.join(muzicari)


with open("trazeniMuzicar.csv") as f:
    for line in zavrsni.collect:
        f.print(line)