from pyspark import SparkConf,SparkContext
from datetime import datetime,date
import csv

def srediDatume(x):
    x[1][1]=datetime.strptime(x[1][1],"%Y-%m-%d").date().year

    if(x[1][2]!="NULL"):
        x[1][2]=datetime.today().year
    else:
        x[1][2]=datetime.strptime(x[1][2],"%Y-%m-%d").date().year

conf=SparkConf().setMaster('local').setAppName('klk')
sc=SparkContext(conf=conf)

muzicari=sc.textFile("muzicari.csv").mapPartitions(lambda x: csv.reader(x)).map(lambda x: (x[0],[x[1],x[2]]))

#id_benda,[id_fest,godina,dan]
line_up=sc.textFile("line_up_festivala.csv").mapPartitions(lambda x: csv.reader(x)).map(lambda x: (x[2],[x[0],x[1],x[3]]))

#id_benda,[id_muz,god1,god2]
sastav_benda=sc.textFile("sastav_benda.csv").mapPartitions(lambda x: csv.reader(x)).map(lambda x: (x[0],[x[1],x[2],x[3]]))
sastav_benda=sastav_benda.map(lambda x: srediDatume(x))

def proveriGodinu(x):
    godFest=x[1][0][1]
    godPoc=x[1][1][1]
    godKraj=x[1][1][2]

    if(godFest>=godPoc and godFest<=godKraj):
        return x

#id_benda,[[idFestivala,godina,dan][id_muz,god1,god2]] ko je svirao koje godine
line_sastav=line_up.join(sastav_benda).filter(lambda x: proveriGodinu(x))

#id_benda,idmuz,[dan]
koJeKogDana=line_sastav.map(lambda x: ((x[0],x[1][1][0]),x[1][0][2]))

#izdvaja one koji su svirali poslednjeg dana
koJePoslDana=koJeKogDana.reduceByKey(lambda x,y: x>y) 

koJePoslDana=koJePoslDana.map(lambda x:(x[0][1],1))

#sabira koliko puta se ko pojavio posl dana
igraci_koliko=koJePoslDana.reduceByKey(lambda x,y: x+y)

maxIgrac=igraci_koliko.map(lambda x: max(x[1]))
#id,[[broj],[ime,prezime]]

trazeni=maxIgrac.join(muzicari).map(lambda x: ((x[1][1][0],x[1][1][1]),x[1][0]))

#print(trazeni.collect())

trazeni=sc.textFile("line_up_festivala.csv").mapPartitions(lambda x: csv.writer(x))







