from pyspark import SparkConf, SparkContext
from datetime import datetime
from time import strptime


conf = SparkConf().setMaster("local").setAppName("SparkKolokvijum")
sc = SparkContext(conf = conf)

def toRdd(csv):
    return sc.textFile(csv).map(lambda x:[y for y in x.split(",")])

def dateToYear(date):
    if date=="NULL":
        return datetime.now.year
    return strptime(date,"%Y-%M-%d").date.year




muzicari = toRdd("muzicari.csv").map(lambda x: (x[0],(x[1],x[2])))
sastavBenda = toRdd("sastav_benda.csv").map(lambda x: (x[1],(x[0],x[2],x[3])))
sastavBenda1 = toRdd("sastav_benda.csv").map(lambda x: (x[0],(x[1],x[2],x[3])))
festivali =  toRdd("lineup_festivala.csv").map(lambda x: (x[2],(x[0],x[1],x[3])))

#(idM,idB),(gPocetak,gKraj)
muzicariuBendu = muzicari.join(sastavBenda1).map(lambda x:((x[0],x[1][1][0]),(x[1][1][1],x[1][1][2])))



#(idM,idB),(idF,godina,dani)
bendoviFestivali = sastavBenda.join(festivali).map(lambda x: ((x[1][0][0],x[0]),(x[1][1][0],x[1][1][1],x[1][1][2]))).filter(lambda x: x[1][2]=="3")

#print(bendoviFestivali.first())

#(idM),(gPocetak,gKraj,idF,godinaFestivala)
muzicariZadnjiDan = muzicariuBendu.join(bendoviFestivali).map(lambda x: (x[0][0],(x[1][0][0],x[1][0][1],x[1][1][0],x[1][1][1])))\
    .filter(lambda x:int(dateToYear(x[1][0]))>=int(x[1][3]) and int(x[1][3])<=int(dateToYear(x[1][1])))\
        .map(lambda x : (x[0],1))

#print(muzicariZadnjiDan.first())


#(idM,brojNastupa)
muzicariBrojNastupa = muzicariZadnjiDan.reduceByKey(lambda x,y: x+y).filter(lambda x:(x[0],max(x[1])))


#(idm,brojNastupa,ime,Prezime)
najviseNastupa = muzicariBrojNastupa.join(muzicari)

#print(najviseNastupa.first())


