from pyspark import SparkContext
from datetime import datetime

def formatirajPodatke(record):
    idMuzicara, idBenda, datum1, datum2 = record
    if datum1 == "NULL":
        datum1 = datetime.now().date()
    else:
        datum1 = datetime.strptime(datum1, "%Y-%m-%d").date()
    if datum2 == "NULL":
        datum2 = datetime.now().date()
    else:
        datum2 = datetime.strptime(datum2, "%Y-%m-%d").date()

    return (idBenda, (idMuzicara, datum1.year, datum2.year))

def daLiJeSviraoTada(godinaFestivala, startYear, finishYear):
    if startYear <= godinaFestivala:
        if finishYear >= godinaFestivala:
            return 10
    return 1

def main():

    sc = SparkContext("local", "festivali")

    lineup = sc.textFile("lineup_festivala.csv").map(lambda line: line.split(",")).map(lambda x: ((x[0], x[1]), (x[2], x[3]))).reduceByKey(lambda x, y: x if x[1] > y[1] else y)
    satsav_benda = sc.textFile("sastav_benda.csv").map(lambda line: line.split(",")).map(lambda x: formatirajPodatke(x))
    muzicari = sc.textFile("muzicari.csv").map(lambda line: line.split(",")).map(lambda x: (x[0], (x[1], x[2])))
    most_common_lives = lineup.map(lambda x: (x[1][0], x[0][1])) #.reduceByKey(lambda x,y: x + y)
      
    joined = most_common_lives.join(satsav_benda).map(lambda x: x[1]).map(lambda x: (x[1][0], daLiJeSviraoTada(x[0], x[1][1], x[1][2]))).filter(lambda x: x[1] == 1)#.map(lambda x: x[0])
    
    resenje = joined.join(muzicari).map(lambda x: x[1]).map(lambda x: ((x[1][0], x[1][1]), 1)).reduceByKey(lambda x, y: x + y)
    print(resenje.collect())
    resenje.saveAsTextFile("trazeniMuzicari.csv")

if __name__ == "__main__":
    main()