from pyspark import SparkContext,SparkConf

def nadjiPoslednjiDan(a,b):
    if(a[1]>b[1]):
        return a[0]
    return b[0]

def filtrirajDane(x, poslednjiDan):
    ind = 0
    for dan in poslednjiDan:
        if(dan == x[1][1]):
            ind = 1  
    if(ind == 1):
        return True
    return False

def dajGodinu(x):
    if(x=='NULL'):
        return 'NULL'
    return x.split('-')[0]

def izdvojGodinu(x):
    drugi = x[1].split(',')
    god1 = drugi[2]
    god2 = drugi[3]
    samoGod1 = dajGodinu(god1)
    samoGod2 = dajGodinu(god2)
    drugiStr = drugi[0]+','+drugi[1]+','+samoGod1+','+samoGod2
    return [x[0], drugiStr]

def uRasponu(x):
    drugi = x[1]
    godina = drugi[1].split(',')[1]
    godinaPoc = drugi[0].split(',')[2]
    godinaKraj = drugi[0].split(',')[3]

    if(godina >= godinaPoc and godina <= godinaKraj)
        return True
    return False

conf = SparkConf().setMaster("local").setAppName("festivali")
sc = SparkContext(conf=conf)

muzicari = sc.textFile("./festivali/muzicari.csv").map(lambda x: [x.split(',')[0], x])

lineup=sc.textFile("./festivali/lineup_festivala.csv")
lineupPoIdju = lineup.map(lambda x: [x.split(',')[0], (x, x.split(',')[3])])

lineupPoslednjiDan = lineupPoIdju.reduceByKey(lambda x,y: nadjiPoslednjiDan(x,y))
poslednjiDan = lineupPoslednjiDan.map(lambda x: x[1].split(',')[3]).collect()

nastupiKonacno = lineupPoIdju.filter(lambda x: filtrirajDane(x, poslednjiDan))

sastavBenda=sc.textFile("./festivali/sastav_benda.csv").map(lambda x: [x.split(',')[1], x]).map(lambda x: izdvojGodinu(x))
nastupiSaSastavom = sastavBenda.join(nastupiKonacno)

nastupiSastavKonacno = nastupiSaSastavom.filter(lambda x: uRasponu(x))
print(nastupiSastavKonacno.collect())

# trazeniMuzicar = []
# izlaz = open("trazeniMuzicar.csv","w")
# izlaz.write(trazeniMuzicar)