from pyspark import SparkConf,SparkContext
import csv
from datetime import datetime,date

conf=SparkConf().setMaster("local").setAppName("kolokvijum")
sc=SparkContext(conf=conf)

def map1(x):
    god1=datetime.strptime(x[1][1],"%Y-%m-%d").date().year
    if x[1][2] != 'NULL':
        god2=datetime.strptime(x[1][2],"%Y-%m-%d").date().year
    else:
        god2=2024
    return (x[0],(x[1][0],god1,god2))
def filter(x,y):
    if x[1][2]>y[1][2]:
        return x
    else:
        return y
def map2(x):
    if int(x[1][0])>=int(x[1][1]): 
        if int(x[1][0])<=int(x[1][2]):
            return x
muzicari=sc.textFile("muzicari.csv").mapPartitions(lambda x:csv.reader(x)).map(lambda x:(x[0],(x[1],x[2])))
festivali=sc.textFile("festivali.csv").mapPartitions(lambda x:csv.reader(x)).map(lambda x:(x[0],(x[1],0)))
sastav=sc.textFile("sastav_benda.csv").mapPartitions(lambda x:csv.reader(x)).map(lambda x:(x[1],(x[0],x[2],x[3])))
lineup=sc.textFile("lineup_festivala.csv").mapPartitions(lambda x:csv.reader(x)).map(lambda x:(x[0],(x[1],x[2],x[3])))
sastav=sastav.map(lambda x:map1(x))
j1=festivali.join(lineup)
j1=j1.reduceByKey(lambda x,y:filter(x,y))
j1=j1.map(lambda x:(x[1][1][1],(x[1][1][0],x[1][0][1])))
j2=j1.join(sastav).map(lambda x:(x[1][1][0],(x[1][0][0],x[1][1][1],x[1][1][2],x[1][0][1])))
j2=j2.filter(lambda x:map2(x))
j3=j2.join(muzicari).map(lambda x:(x[1][1][0],x[1][1][1],x[1][0][3]))
for x in j3.collect():
    print(x)
with open ("trazeniMuzicar.csv","w") as f:
    for x in j3.collect():
       f.write(x[0]+ "," +x[1]+ ","+ str(x[2])+"\n")

