from pyspark import SparkConf, SparkContext
conf = SparkConf().setMaster("local").setAppName("App")
sc = SparkContext(conf = conf)

import csv
from datetime import datetime, date

def transform(x):
    godina1 = datetime.strptime(x[2], "%Y-%m-%d").date().year
    if x[3] == "NULL":
        godina2 = date.today().year
    else:
        godina2 = datetime.strptime(x[3], "%Y-%m-%d").date().year
    
    return (x[1], (x[0], godina1, godina2))

sastav_benda = sc.textFile("sastav_benda.csv").mapPartitions(lambda x: csv.reader(x)).map(lambda x: transform(x))
lineup_festivala = sc.textFile("lineup_festivala.csv").mapPartitions(lambda x: csv.reader(x)).map(lambda x: (x[2], (x[0], x[1], x[3])))
muzicari = sc.textFile("muzicari.csv").mapPartitions(lambda x: csv.reader(x)).map(lambda x: (x[0], (x[1], x[2])))

def filtriraj(x):
    godina1 = int(x[1][0][1])
    godina2 = int(x[1][0][2])

    godinaFestivala = int(x[1][1][1])

    if godinaFestivala >= godina1 and godina2 >= godinaFestivala:
        return True
    else:
        return False

def filtriraj2(x,y):
    if(x[2] > y[2]):
        return x
    return y


j1 = sastav_benda.join(lineup_festivala).filter(lambda x: filtriraj(x))
j1 = j1.map(lambda x: (x[1][1][0], (x[0], x[1][0][0], x[1][1][2]))).reduceByKey(lambda x,y: filtriraj2(x,y))
j1 = j1.map(lambda x: (x[1][1], 1)).reduceByKey(lambda x,y: x+y)

maksimum = 0
for x in j1.collect():
    if x[1] > maksimum:
        maksimum = x[1]
    
j1 = j1.filter(lambda x: x[1] == maksimum)

j2 = j1.join(muzicari).map(lambda x: (x[1][1][0], x[1][1][1], x[1][0]))

with open("trazeniMuzicar.csv", "w") as f:
    for x in j2.collect():
        f.write(x[0]+","+x[1]+","+str(x[2])+"\n")
