import csv
from pyspark import SparkConf, SparkContext
from datetime import datetime

def getRddFromCsv(path):
    return sc.textFile(path).mapPartitions(lambda x: csv.reader(x)) 

def loadLineupFestivala(x):
    id_festivala, godina, id_benda, dan = int(x[0]), int(x[1]), int(x[2]), int(x[3])
    return((id_festivala), (dan, godina, id_benda))

def loadSastavBenda(x):
    id_muzicara, id_benda, godina_1, godina_2 = int(x[0]), int(x[1]), x[2], x[3]
    godina_1 = datetime.strptime(godina_1, "%Y-%m-%d").year
    if godina_2 != "NULL": 
        godina_2 = datetime.strptime(godina_2, "%Y-%m-%d").year
    else:
        godina_2 = 2024
    return ((id_benda),(id_muzicara, godina_1,godina_2))


def dajMaxUDanima(x,y):
    if x is not None and y is not None:

        # print(x[0])
        # print(y[0])
        if int(x[0]) > int(y[0]):
            return (x[0],"max_dana")
        return (y[0],"max_dana")
    
def dajSamoOneKojiSuSvirali(x):
    if x[1][0][2] >= x[1][1][1] or x[1][0][2] >= x[1][1][2]:
        return x

conf = SparkConf().setMaster("local").setAppName("festivali")
sc = SparkContext(conf = conf)

# (idFestivala, godina, idBenda, dan)
lineup_festivala_rdd = getRddFromCsv("lineup_festivala.csv")
lineup_festivala_rdd = lineup_festivala_rdd.map(lambda x: loadLineupFestivala(x))
max_dana = lineup_festivala_rdd.reduceByKey(lambda x,y: dajMaxUDanima(x,y))

# festival_id (dan, godina, id_benda)
joined = lineup_festivala_rdd.join(max_dana).filter(lambda x: x[1][0][0] == x[1][1][0])

# id_benda (festival_id, godina)
joined = joined.map(lambda x: (x[1][0][2], (x[0], x[1][1][0], x[1][0][1])))


sastav_benda_rdd = getRddFromCsv("sastav_benda.csv")
sastav_benda_rdd = sastav_benda_rdd.map(lambda x: loadSastavBenda(x))

new_join = joined.join(sastav_benda_rdd).filter(lambda x: dajSamoOneKojiSuSvirali(x))

new_join = new_join.map(lambda x: (x[0], x[1][0][2]))

new_join.saveAsTextFile("izlaz")

# print(joined.collect())
# print(sastav_benda_rdd.collect())
print(new_join.collect())
# print(new_join.collect())
# print(max_dana.collect())
# print(sastav_benda_rdd.collect())

