from pyspark import SparkContext, SparkConf
from datetime import date, datetime
import csv

conf = SparkConf().setMaster("local").setAppName("festivali")
sc = SparkContext(conf = conf)

def funkcija(x):
    if(x[1][1]):
        x[1][1] = datetime.strptime(x[1][1], "%Y-%m-%d").year
    if(x[1][2] == "NULL"):
        x[1][2] = 2024
    else:
        x[1][2] = datetime.strptime(x[1][2], "%Y-%m-%d").year

    return x

#(idBenda, [idFestivala, godina, dan, maksDan], [idMuzicara, datum1, datum2])
def daLiJeNastupao(x):
    godinaFest = x[1][0][1]
    datum1 = x[1][1][1]
    datum2 = x[1][1][2]

    if(godinaFest >= datum1 and godinaFest <= datum2):
        return True

    return False

def daLiJePoslednjiDan(x):
    dan = x[1][0][2]
    makss = x[1][0][3]
    if(dan == makss):
        return True
    
    return False

muzicari = sc.textFile("muzicari.csv").mapPartitions(lambda x: csv.reader(x)).map(lambda x: (x[0], [x[1], x[2]]))
print(muzicari.collect())

#(idBenda, [idMuzicara, datum1, datum2])
sastav_benda = sc.textFile("sastav_benda.csv").mapPartitions(lambda x: csv.reader(x)).map(lambda x: (x[1], [x[0], x[2], x[3]]))
sastav_benda = sastav_benda.map(lambda x: funkcija(x))
print(sastav_benda.collect())

#(idFestivala, [godina, idBenda, dan])
lineup_festivala = sc.textFile("lineup_festivala.csv").mapPartitions(lambda x: csv.reader(x)).map(lambda x: (x[0], [datetime.strptime(x[1], "%Y").year, x[2], x[3]]))
print(lineup_festivala.collect())

festivali = sc.textFile("festivali.csv").mapPartitions(lambda x: csv.reader(x)).map(lambda x: (x[0], x[1]))
print(festivali.collect())

def nadjiMax(x):
    maksDana = x[1][2]
    festival = x[0]
    for red in lineup_festivala.collect():
        if(red[1][2] > maksDana and festival == red[0]):
            maksDana = red[1][2]
    return maksDana

#festivalMaxDani = lineup_festivala.map(lambda x: (x[0], x[1][2])).max()

maksDan = lineup_festivala.map(lambda x: (x[0], x[1][2])).reduceByKey(lambda x, y: max(x, y))
print(maksDan.collect())

#(idBenda, [idFestivala, godina, dan, maksDan])
lineupJoinMaksDan = lineup_festivala.join(maksDan).map(lambda x: (x[1][0][1], [x[0], x[1][0][0], x[1][0][2], x[1][1]]))
print(lineupJoinMaksDan.collect())

#(idBenda, [idFestivala, godina, dan, maksDan], [idMuzicara, datum1, datum2])
rezJoinMuzicari = lineupJoinMaksDan.join(sastav_benda).filter(lambda x: daLiJeNastupao(x))
print(rezJoinMuzicari.collect())

#(idMuzicara, 1)
rezJoinMuzicari = rezJoinMuzicari.filter(lambda x: daLiJePoslednjiDan(x))

konacno = rezJoinMuzicari.map(lambda x: (x[1][1][0], 1))
konacno = konacno.reduceByKey(lambda x, y: x+y)

konacno = konacno.join(muzicari).map(lambda x: (x[0], [x[1][1][0], x[1][1][1], x[1][0]]))

br = 0
for red in konacno.collect():
    if(red[1][2] > br):
        br = red[1][2]

konacniMuzicari = konacno.filter(lambda x: x[1][2] == br)
print("Muzicari koji su najcesce svirali na zavrsnim danima i broj njihovih sviranja su: ")
print(konacniMuzicari.collect())