#!/bin/bash

from pyspark import SparkContext
from datetime import datetime

sp = SparkContext("local", "festivali")
sp.setLogLevel("ERROR")

def toRDD(csv):
    return sp.textFile(csv).map(lambda x: [y.strip() for y in x.split(',')])

def datum(date):
    if(date == "NULL"):
        return datetime.today().date().year
    return datetime.strptime(date, "%Y-%M-%d").date().year

def opseg(g, pS, kS):
    if(pS <= g):
        if(kS >= g):
            return 1
    return 0

muzicari = toRDD("muzicari.csv").map(lambda x: (x[0], (x[1], x[2])))
sastavBenda = toRDD("sastav_benda.csv").map(lambda x: (x[0], x[1], (x[2], x[3])))
lineup = toRDD("lineup_festivala.csv").map(lambda x: (x[2], x[1], x[3]))

# (ime, prezime, godina, dan, brojNastupa)
trazeni = muzicari.join(sastavBenda) \
            .map(lambda x: (x[0], (x[1][0], x[1][1]), x[2], x[3][0], x[3][1])) \
            .join(lineup) \
            .map(lambda x: (x[2], (x[1][0], x[1][1]), (x[3][0], x[3][1]), x[4], x[5])) \
            .filter(lambda x: opseg(x[4], datum(x[3][0]), datum(x[3][1])) == 1) \
            .map(lambda x: (x[1][0], x[1][1], x[4], x[5])) \
            .sort(lambda x: (x[2], -x[3])) \
            .groupBy(lambda x: (x[2], x[0], x[1])) \
            .map(lambda x: ((x[0], x[1]), x[2], list(x[3])[0]), 1) \
            .reduceByKey(lambda x, y: x[4] + y[4]) \
            .map(lambda x: (x[0][1], x[0][2], x[4])) 
            # (ime, prezime, brojNastupa)          

f = trazeni.collect()
for r in f:
    print(r)
            
            

