from pyspark import SparkConf, SparkContext
import csv
from datetime import datetime

conf = SparkConf().setMaster("local").setAppName("festivali")
sc = SparkContext(conf = conf)

def dateToYear(datum):
    if datum == "NULL":
        return datetime.today().date().year
    return datetime.strptime(datum, "%Y-%M-%d").date().year

def daLiJeUcestvovao(festival, start, end):
    if festival > start and festival < end:
        return 1
    return 0

#(3, ('2008', '2', 2))
lineup_festivala = sc.textFile("lineup_festivala.csv")\
                    .mapPartitions(lambda x: csv.reader(x))\
                    .map(lambda x: (int(x[2]), (int(x[0]), int(x[1]), int(x[3]))))

# for x in lineup_festivala.collect():
#     print(x)

# poslednji_dan = lineup_festivala.map(lambda x: (x[1][0], (x[1][1], x[1][2])))\
#                 .reduceByKey(lambda x, y: max(x[1], y[1]) if x[1] == y[1] else None)

poslednji_dan = lineup_festivala.map(lambda x: (x[1][0], x[1][2]))\
                .reduceByKey(lambda x, y: max(x, y))

# for x in poslednji_dan.collect():
#     print(x)

#(16, 'Tim Be')
muzicari = sc.textFile("muzicari.csv")\
                    .mapPartitions(lambda x: csv.reader(x))\
                    .map(lambda x: (int(x[0]), (x[1].strip()+" "+x[2].strip())))
                
for x in muzicari.collect():
    print(x)

#(1, (1, 5, 1, 0))
#(5, ((1, 3, 1), 'Ivan Firci'))
sastav_benda = sc.textFile("sastav_benda.csv")\
                    .mapPartitions(lambda x: csv.reader(x))\
                    .map(lambda x: (int(x[1]), (int(x[0]), dateToYear(x[2]), dateToYear(x[3]))))\
                    .join(lineup_festivala)\
                    .map(lambda x: (x[0], (x[1][1][0], x[1][0][0], x[1][1][2],daLiJeUcestvovao(x[1][1][1], x[1][0][1], x[1][0][2]),x[1][1][1] )))\
                    .filter(lambda x: x[1][3] > 0)\
                    .map(lambda x: (x[1][1], (x[0], x[1][0], x[1][2], x[1][4])))\
                    .join(muzicari)\
                    .map(lambda x: (x[1][0][0], (x[1][1], x[1][0][3])))\
                    .join(poslednji_dan)\
                    .map(lambda x: (x[1][0][0], x[1][0][1]))
                
# for x in sastav_benda.collect():
#     print(x)

f = open("izlaz.txt", "w")
for x in sastav_benda.collect():
    f.write(x[0]+","+x[1])
    f.write("\n")
f.close()