from pyspark import SparkConf, SparkContext
import csv

conf = SparkConf().setMaster("local").setAppName("kolokvijum")
sc = SparkContext(conf = conf)

lineup_festivala_df = sc.textFile("lineup_festivala.csv").map(lambda x: str(x).split(","))
sastav_benda_df = sc.textFile("sastav_benda.csv").map(lambda x: str(x).split(",")).map(lambda x: (x[0], x[1], int(str(x[2]).split("-")[0]), int("2024" if str(x[3]).split("-")[0] == "NULL" else str(x[3]).split("-")[0])))
muzicari_df = sc.textFile("muzicari.csv").map(lambda x: str(x).split(",")).map(lambda x: (x[0], x[1] + " " + x[2]))

festivali_po_godini_df = lineup_festivala_df.map(lambda x: ((x[0], int(x[1])), x[3])).reduceByKey(lambda a, b: max(a, b))

pevali_bendovi_df = lineup_festivala_df.map(lambda x: ((x[0], int(x[1])), (x[2], x[3])))

pevali_poslednjeg_dana_df = pevali_bendovi_df.join(festivali_po_godini_df).filter(lambda x: x[1][0][1] == x[1][1])

pevali_poslednjeg_dana_df = pevali_poslednjeg_dana_df.map(lambda x: (x[1][0][0], x[0][1]))

sastav_benda_df = sastav_benda_df.map(lambda x: (x[1], (x[0], x[2], x[3])))

svirali_tada_df = pevali_poslednjeg_dana_df.join(sastav_benda_df).map(lambda x: x[1]).filter(lambda x: x[0] in range(x[1][1], x[1][2] + 1))
svirali_poslednjeg_dana_df = svirali_tada_df.map(lambda x: (x[1][0], 1)).reduceByKey(lambda a, b: a + b)

max_sviranja = svirali_poslednjeg_dana_df.map(lambda x: x[1]).max()

najvise_svirali_df = svirali_poslednjeg_dana_df.filter(lambda x: x[1] == max_sviranja)

najvise_svirali_df = najvise_svirali_df.join(muzicari_df).map(lambda x: (x[0], x[1][1], x[1][0]))

# cuvam kao (idMuzicara, ime, brojSviranjaPoslednjegDana)
najvise_svirali_df.saveAsTextFile("trazeniMuzicari.csv")

for a in najvise_svirali_df.collect():
    print (a)