from pyspark import SparkConf, SparkContext

conf = SparkConf().setMaster("local").setAppName("SparkKolokvijum")
sc = SparkContext(conf = conf)

from datetime import datetime

def toRdd(csv):
    return sc.textFile(csv).filter(lambda x: x.strip() != "").map(lambda x: [ y.strip() for y in x.split(',')])

def dateToYear(date):
    if date=="NULL":
        return datetime.today().year
    return datetime.strptime(date,"%Y-%m-%d").date().year

muzicari = toRdd("muzicari.csv") 

bendovi = toRdd("sastav_benda.csv") \
    .map(lambda x: (int(x[1]), (int(x[0]), dateToYear([2]), dateToYear(x[3]))))

festivali1 = toRdd("lineup_festivala.csv")\
    .map(lambda x: ((x[0], x[1]), (x[2],x[3])))


festivali = toRdd("lineup_festivala.csv")\
    .map(lambda x: (x[2],(x[0], x[1], x[3]))) \
    .join(bendovi) \
    .filter(lambda x: x[1][0][1] >= x[1][1][0] and x[1][0][1] < x[1][1][1]) \
    .map(lambda x: ( (x[1][0][0], x[1][0][2]), x[0])) \
    .join(festivali1) \
    .filter(lambda x: x[1][0] >= x[1][1][1]) \
    .map(lambda x: (x[1][0],1)) \
    .reduceByKey(lambda x, y: x + y) \
    .join(muzicari)\
    .map(lambda x: (x[0], x[1][0], x[1][1])) \
    .filter(lambda x: x[0] > 0)
    

festivali.saveAsTextFile("najcesci.txt")