from pyspark import SparkConf, SparkContext
import csv
from datetime import datetime, date

conf=SparkConf().setMaster("local").setAppName("festivali")
sc=SparkContext(conf=conf)

def srediDatum(date):

    if(date=="NULL"):
        return date.today().year
    else:
        return datetime.strptime(date, "%Y-%M-%d").date().year

muzicari=sc.textFile("muzicari.csv").mapPartitions(lambda x: csv.reader(x)).map(lambda x: (x[0], (x[1],x[2]))) #idM, ime, prezime 
sastav_benda=sc.textFile("sastav_benda.csv").mapPartitions(lambda x: csv.reader(x)).map(lambda x: (x[0],(x[1], srediDatum(x[2]), srediDatum(x[3])))) #idM, idB, datum1, datum2
lineup_festivali=sc.textFile("lineup_festivala.csv").mapPartitions(lambda x: csv.reader(x)).map(lambda x: (x[2], (x[0],x[1],x[3]))) #idB, godina, idF, dan

muzicariBend=muzicari.join(sastav_benda).map(lambda x: (x[1][1][0], (x[1][0][0],x[1][0][1],x[0], x[1][1][1],x[1][1][2]))) #idB, ime,prez, idM,datum1,datum2
lineup=muzicariBend.join(lineup_festivali).map(lambda x: (x[0], x[1][0][2], x[1][1][0],x[1][0][3],x[1][0][4] ,x[1][1][2])).filter(lambda x: ()) #idB, idM, god,datum1, datum2, dan
#ovde mora godina da se posmatra
najveciDan=0

def najveci(dan):
    if(dan>najveciDan):
        najveciDan=dan
    return najveciDan

#idB, dan
psolednjiDan=lineup.map(lambda x: (x[0], x[1][1][2])).reduceByKey(lambda x,y: x if x[1] > y[1] else y).map(lambda x: (x[0],1)).reduceByKey(lambda x,y: x+y).filter(lambda x: najveci(x[1])) #da ostane najveci dan  

sastav_benda=sastav_benda.map(lambda x: (x[1], x[0])) #idB, idM

krajnje=psolednjiDan.join(sastav_benda).map(lambda x: (x[1][1], x[1][0])) #idM, dan
krajnje=krajnje.join(muzicari).map(lambda x: (x[0], (x[1][1][0], x[1][1][1], x[1][0]))) #id, ime, prezime, dan

for x in krajnje.collect():
    print(x[1][1][0], x[1][1][1], x[1][0]) 