from pyspark import SparkConf, SparkContext

conf = SparkConf().setMaster("local").setAppName("muzicari")

ctx = SparkContext(conf = conf)

lineup = ctx.textFile("lineup_festivala.csv").map(lambda x: x.split(","))
lineupLastDay = lineup.map(lambda x: (x[0],int(x[3]))).reduceByKey(max).map(lambda x: ((x[0], x[1]), 0))
bendoviLastDay = lineupLastDay.join(lineup.map(lambda x: ((x[0],int(x[3])), x[1], x[2]))).map(lambda x: (x[0][0],int(x[1][1])))

bendovi = ctx.textFile("sastav_benda.csv").map(lambda x: x.split(",")).map(lambda x: (x[1], (x[0], int(x[2][0:4]), 2024 if x[3] == "NULL" else int(x[3][0:4]))))

muzicariLastDay = bendoviLastDay.join(bendovi).filter(lambda x: x[1][1][1]<= x[1][0]<=x[1][1][2]).map(lambda x: (x[1][1][0], 1)).reduceByKey(lambda x, y: x+y)

najbolji = muzicariLastDay.reduce(lambda x, y: x if x[1] > y[1] else y)

najboljiMuzicar = ctx.textFile("muzicari.csv").map(lambda x: x.split(",")).map(lambda x: (x[0], (x[1],x[2]))).filter(lambda x: x[0] == najbolji[0]).map(lambda x: (str(x[1][0]), str(x[1][1]), str(najbolji[1]))).collect()

f = file("trazeniMuzicar.csv", "w")
f.write(",".join(najboljiMuzicar[0]))
f.close()

