from pyspark import SparkContext, SparkConf
import csv
import time

conf = SparkConf().setMaster("local").setAppName("Kolokvijum")
cs = SparkContext(conf = conf)

def daLiJeMuzicarSviraoUToVreme(row):
    return (row, '0')

festivali = cs.textFile("festivali.csv").mapPartitions(lambda x: csv.reader(x)).map(lambda x: (x[0], x[1]))
lineup_festivala = cs.textFile("lineup_festivala.csv").mapPartitions(lambda x: csv.reader(x)).map(lambda x: (x[0], (x[1], x[2], x[3])))
sastav_benda = cs.textFile("sastav_benda.csv").mapPartitions(lambda x: csv.reader(x)).map(lambda x: (x[0],(x[1],x[2],x[3])))
muzicari = cs.textFile("muzicari.csv").mapPartitions(lambda x: csv.reader(x)).map(lambda x: (x[0], (x[1], x[2])))

#(idBenda, idFestivala, nazivFestivala, godina, dan)
lineupFest = festivali.join(lineup_festivala).map(lambda x: (x[1][1][1], (x[0], x[1][0], x[1][1][0], x[1][1][1] ,x[1][1][2]))) 

#(idBenda, ((  idMuzicara, dat1, dat2  ), (  idFestivala, nazivFestivala, godina, dan  )))
#(idMuzicara, ( dat1 , dat2 ), (idFestivala, nazivFestivala, godina , dan))
bendoviPoLineupu = sastav_benda.join(lineupFest).map(lambda x: (x[1][0][0], ((x[1][0][1], x[1][0][2]), (x[1][1][0], x[1][1][1], x[1][1][2], x[1][1][3]))))

#(idMuzicara, (( dat1 , dat2 ), (idFestivala, nazivFestivala, godina , dan) , 0))
muzicariKojiSuZapravoSvirali = bendoviPoLineupu.map(daLiJeMuzicarSviraoUToVreme) #.filter(lambda x: x[1][1][2] == 0 )

#(idFestivala, naziv), (idMuzicara, dan, 0)
muzicariPoFestivalima = muzicariKojiSuZapravoSvirali.map(lambda x: ((x[0][1][1][0], x[0][1][1][1]), ( x[0][0], x[0][1][1][3], x[1])))

poslednjiDan = muzicariPoFestivalima.reduceByKey(lambda x,y: x if int(x[2]) > y else y )

#(idMuzicara, (naziv, idFestivala, broj))
resenjeBezImena = poslednjiDan.map(lambda x: (x[1][0], (x[0][1], x[0][0], x[1][2])))

resenje = resenjeBezImena.join(muzicari).map(lambda x: (x[1][0][0], (x[1][1], x[1][0][2])))

resenje.saveAsTextFile("trazeniMuzicar")

