from pyspark import SparkConf, SparkContext
import csv
import sys

conf = SparkConf().setMaster("local").setAppName("SparkKolokvijum")
sc = SparkContext(conf = conf)

def formatiraj(x):
    return [x[1],[x[0],x[2][0:4],x[3][0:4]]]

lineup_df = sc.textFile("festivali/lineup_festivala.csv").mapPartitions(lambda x: csv.reader(x))
lineup_zadnji_df = lineup_df.map(lambda x: [(x[0],x[1]), x[3]]).groupByKey().map(lambda x: [x[0], max(x[1])]) 
#id_fest, god, zadnjiDan

lineup_df = lineup_df.map(lambda x: [(x[0],x[1]),x[3]])
#id_fest, god, idBenda
lineup_zadnji_df = lineup_zadnji_df.join(lineup_df).map(lambda x: [x[1][1], [x[0][0], x[0][1]]])
#id_fest, god - zadnjiDan, idBenda => id_benda, [id_fest, godina]

sastav_df = sc.textFile("festivali/sastav_benda.csv").mapPartitions(lambda x: csv.reader(x)).map(lambda x: formatiraj(x))
lineup_sastav_df = lineup_zadnji_df.join(sastav_df).filter(lambda x: int(x[1][0][1]) >= int(x[1][1][1]) and (x[1][1][2]=='NULL' or int(x[1][0][1]) <= int(x[1][1][2])))
# id_benda, [[id_fest, god], [idMuz,pocGod,KrajGod]] 
lineup_sastav_df = lineup_sastav_df.map(lambda x: [x[1][1][0],1])
# id_fest, god, idMuz , 1

muzicar_nastupi_df = lineup_sastav_df.reduceByKey(lambda a,b: a+b)
# id_muz, nastupa

muzicari_df = sc.textFile("festivali/muzicari.csv").mapPartitions(lambda x: csv.reader(x)).map(lambda x: [x[0], [x[1], x[2]]])
muzicar_nastupi_df = muzicar_nastupi_df.join(muzicari_df).map(lambda x: [x[0], x[1][0], x[1][1][0], x[1][1][1]])
# id_muz, [brnastupa, [ime, prez]]

najvise_nastupa = muzicar_nastupi_df.map(lambda x: x[1]).max()

najbolji_muzicar = muzicar_nastupi_df.filter(lambda x: x[1] == najvise_nastupa)
najbolji_muzicar = najbolji_muzicar.map(lambda x: [x[2] + " " + x[3], x[1]])

# writer = csv.writer("izlaz.csv")
# writer.writerow(najbolji_muzicar.collect())
# print(najbolji_muzicar.collect(), file=sys.__file__)

print(najbolji_muzicar.collect())
# print("AAAAAA", najvise_nastupa)